标签:style blog color java os strong for 问题
题目:
Follow up for "Unique Paths":
Now consider if some obstacles are added to the grids. How many unique paths would there be?
An obstacle and empty space is marked as 1
and 0
respectively in the grid.
For example,
There is one obstacle in the middle of a 3x3 grid as illustrated below.
[ [0,0,0], [0,1,0], [0,0,0] ]
The total number of unique paths is 2
.
Note: m and n will be at most 100.
题解:
这道题大体想法跟Unique Path是一样的。
只是要单独考虑下障碍物对整个棋盘的影响。
先看看初始条件会不会受到障碍物的影响。
假设整个棋盘只有一行,那么在第i个位置上设置一个障碍物后,说明位置i到最后一个格子这些路都没法走了。
如果整个棋盘只有一列,那么第i位置上的障碍物,也会影响从第i位置往后的路。
所以说明,在初始条件时,如果一旦遇到障碍物,障碍物后面所有格子的走法都是0。
再看求解过程,当然按照上一题的分析dp[i][j] = dp[i-1][j] + dp[i][j-1] 的递推式依然成立(机器人只能向下或者向右走嘛)。但是,一旦碰到了障碍物,那么这时的到这里的走法应该设为0,因为机器人只能向下走或者向右走,所以到这个点就无法通过。
处理完障碍物的特殊问题,依照unique paths改一下代码就好。
代码如下:
Unique Paths II leetcode java,布布扣,bubuko.com
标签:style blog color java os strong for 问题
原文地址:http://www.cnblogs.com/springfor/p/3886644.html